#include "StdAfx.h"
#include "NeMessengerDlg.h"
#include "FavoriteView.h"
#include "FavoriteController.h"
#include "resource.h"
#include "..\..\DuiLib\UIlib.h"
#include "main_frame.hpp"

FavoriteView::FavoriteView(void)
{
	m_pDuiList = NULL;
    m_favoriteController = NULL;
}

FavoriteView::~FavoriteView(void)
{
	m_ImageList.DeleteImageList();
}

void FavoriteView::DeleteAllItems()
{
	CSingleLock lock(&m_csFavoriteView);
	lock.Lock();
	m_pDuiList->DeleteAllItem();
	m_userIdMap.clear();

	lock.Unlock();
}
void FavoriteView::AddGroup574(LPCWSTR strGroupName, const IGTBuddyGroup* pGroup,
							bool bEditLabel, bool bExpand)
{
	CSingleLock lock(&m_csFavoriteView);
	lock.Lock();

	CString strGroupID;
	strGroupID.Format(_T("%d"), pGroup->GetID());
	if (m_pDuiList == NULL)
	{
		m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
	}
	if (m_pDuiList != NULL)
	{
		m_pDuiList->AddGroup(strGroupName, strGroupID, pGroup->GetSortOrder(), (DWORD) pGroup, bEditLabel);
		if(bEditLabel)
		{
			m_pDuiList->PageDown();
			m_pDuiList->SetNodeEdit(pGroup->GetID());
		}
	}

	m_groupIdMap574.insert(make_pair(pGroup->GetID(), strGroupName));

	
	lock.Unlock();
}



bool FavoriteView::IsExistBuddy(Node* hParentItem,LPCWSTR strUserId)
{
	bool bRet=false;
	if(hParentItem == NULL)
	{
		//̰ ɸ ȵȴ.
		ASSERT(FALSE);
	}

	/*for(HTREEITEM hRootItem = m_ctrlFavoriteTree.GetChildItem(hParentItem); 
		hRootItem != 0; hRootItem = m_ctrlFavoriteTree.GetNextSiblingItem(hRootItem))
	{		

		if(false==m_ctrlFavoriteTree.IsGroup(hRootItem))
		{
			const IGTBuddyUser* pUser = NULL;
			pUser = (IGTBuddyUser *) m_ctrlFavoriteTree.GetItemData(hRootItem);

			if (pUser->GetUserID() == strUserId)
			{
				bRet=true;
			}
		}
	}*/
	return bRet;

}

const CString FavoriteView::GetItemDisplayText(const IGTBuddyUser* pUser)
{
	CString strRet;
	LPCWSTR strUserID = pUser->GetUserID();
	const NE_MEMBER_DATA *data = g_pMessengerActor->GetEmployeeInfo(strUserID);
	if (data)
	{
		strRet =GetDisPlayName(data);
	}
	else
	{
		strRet = strUserID;
	}
	return strRet;

}
const CString FavoriteView::GetItemWorkStatusText( const IGTBuddyUser* pUser )
{
	if (NULL == pUser)
	{
		return L"";
	}
	CString strRet;
	LPCWSTR strUserID = pUser->GetUserID();
	const NE_MEMBER_DATA *data = g_pMessengerActor->GetEmployeeInfo(strUserID);
	if (data)
	{
		strRet = data->strWorkStatus.c_str();
	}
	else
	{
		strRet =L"";
	}

	return strRet;
}

void FavoriteView::AddBuddy574(const IGTBuddyUser* pUser, int nGroupID)
{
	CSingleLock lock(&m_csFavoriteView);
	lock.Lock();

	std::map<int, CString>::const_iterator groupIterator = m_groupIdMap574.find(nGroupID);
	if (groupIterator != m_groupIdMap574.end())
	{
		CString groupName = groupIterator->second;
		LPCWSTR strUserId = pUser->GetUserID();
		CString strText;

		const NE_MEMBER_DATA *data = g_pMessengerActor->GetEmployeeInfo(strUserId);
		if (data)
		{
			int nDisplayType = GET_CONFIG()->GetNameDisplayType();
			if (nDisplayType == 0 || nDisplayType == 1)
				strText = pUser->GetName();

			strText += GetDisPlayName(data);
		}
		else
		{
			strText = strUserId;
			ASSERT(FALSE);
            return ;    //add this avoid AddBuddy(NULL) crash, user:nt90544@nts.nhncorp, maybe left?
		}
		

		if (m_pDuiList == NULL)
		{
			m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
		}
		if (m_pDuiList != NULL)
		{
			m_pDuiList->AddBuddy(data, nGroupID, (DWORD)pUser);
		}
		
	}
	else
	{
		ASSERT(FALSE);
	}

	lock.Unlock();

}

void FavoriteView::UpdataAllBuddyImage()
{
	if (m_pDuiList == NULL)
	{
		m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
	}
	if (m_pDuiList != NULL)
	{
		m_pDuiList->UpdataAllBuddyImage();
	}
}
void FavoriteView::ResortBuddyInGroup(int nGroupID){

	CSingleLock lock(&m_csFavoriteView);
	lock.Lock();
	if (m_pDuiList == NULL)
	{
		m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
	}
	if (m_pDuiList != NULL)
	{
		m_pDuiList->ResortBuddyInGroup(nGroupID);
	}
    lock.Unlock();
}

void FavoriteView::SetList(CBuddyTreeCtrl* pBuddyList)
{
	m_pDuiList = pBuddyList;
}

std::vector<Node*> FavoriteView::GetSelectedItems(void)
{
	std::vector<Node*> vecSelectedItem;

	if (m_pDuiList == NULL)
	{
		m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
	}

	vecSelectedItem = m_pDuiList->GetSelectedItems();

	return vecSelectedItem;
}

std::vector<Node*> FavoriteView::GetAllItems(void)
{
	std::vector<Node*> vecAllItem;
	
	vecAllItem = m_pDuiList->GetAllItems();

	return vecAllItem;
}

void FavoriteView::RepeatHitemFilter( std::vector<Node*>& vec_in,  std::vector<Node*>& vec_out)
{
	std::map<Node*, int> mapFilter;
	int nSize = vec_in.size();
	for (int i=0; i<nSize; i++)
	{
		pair<Node*, int>item(vec_in[i],i);
		mapFilter.insert(item);
	}
	std::map<Node*, int>::iterator iter;
	for (iter = mapFilter.begin();iter!=mapFilter.end();iter++)
	{
		vec_out.push_back(vec_in[iter->second]);
	}
}
const std::vector<const IGTBuddyUser *> FavoriteView::SelectedBuddyUsers()
{
	std::vector<const IGTBuddyUser *> selectedBuddyItems;
	std::vector<Node*> vecSelectedTreeItem = SelectedBuddyItems();
	for(std::vector<Node*>::iterator itr = vecSelectedTreeItem.begin(); itr != vecSelectedTreeItem.end(); itr++)
	{
		Node* pNode= *itr;
		if(!IsGroup(pNode)) // ׷
		{
            //if delete the buddy user and select from recent user, then crash
			//  const IGTBuddyUser *pUser = (const IGTBuddyUser *)pNode->GetNodeUserData();

            CString strUserId = pNode->data().value;
			Node* pGroupNode = pNode->parent();
			if(pGroupNode == NULL) continue;
			
			const IGTBuddyGroup *pGroup = (const IGTBuddyGroup *)pGroupNode->GetNodeUserData();
			if(pGroup == NULL) continue;

            const IGTBuddyUser *pUser = g_pMessengerActor->GetBuddyInfo(strUserId, pGroup->GetID());
            if (NULL == pUser)
            {
                pUser = g_pMessengerActor->GetBuddyInfoFromPersist(strUserId);
            }
            ASSERT(pUser);
            if (pUser)
            {
                selectedBuddyItems.push_back(pUser);
            }
		}
	}
	return selectedBuddyItems;
}

const std::vector<const IGTBuddyGroup *> FavoriteView::SelectedGroups()
{
	std::vector<const IGTBuddyGroup *> selectedGroupItems;
	std::vector<Node*> vecSelectedTreeItem = SelectedGroupItems();
	for(std::vector<Node*>::iterator itr = vecSelectedTreeItem.begin(); itr != vecSelectedTreeItem.end(); itr++)
	{
		Node* pNode= *itr;
		const IGTBuddyGroup *pGroup = (const IGTBuddyGroup *)pNode->GetNodeUserData();
        ASSERT(pGroup);
        if (pGroup)
        {
            selectedGroupItems.push_back(pGroup);
        }
	}

	return selectedGroupItems;
}

const std::vector<const IGTBuddyGroup *> FavoriteView::AllGroups()
{
	std::vector<const IGTBuddyGroup *> allGroupItems;
	std::vector<Node*> vecAllTreeItem = AllGroupItems();
	for(std::vector<Node*>::iterator itr = vecAllTreeItem.begin(); itr != vecAllTreeItem.end(); itr++)
	{
		Node* pNode= *itr;

		const IGTBuddyGroup *pGroup = (const IGTBuddyGroup *)pNode->GetNodeUserData();
        ASSERT(pGroup);
        if (pGroup)
        {
            allGroupItems.push_back(pGroup);
        }
	}

	return allGroupItems;
}

const std::vector<Node*> FavoriteView::SelectedGroupItems()
{
	std::vector<Node*> vecTreeItem = GetSelectedItems();
	std::vector<Node*> vecRet;
	for(std::vector<Node*>::iterator itr = vecTreeItem.begin(); itr != vecTreeItem.end(); itr++)
	{
		Node* pNode= *itr;

		if(IsGroup(pNode) ) // ׷
		{
			vecRet.push_back(pNode);
		}
	}

	return vecRet;
}

const std::vector<Node*> FavoriteView::AllGroupItems()
{
	std::vector<Node*> vecTreeItem = GetAllItems();
	std::vector<Node*> vecRet;
	for(std::vector<Node*>::iterator itr = vecTreeItem.begin(); itr != vecTreeItem.end(); itr++)
	{
		Node* pNode= *itr;

		if(IsGroup(pNode)) // ׷
		{
			vecRet.push_back(pNode);
		}
	}

	return vecRet;
}

const std::vector<Node*> FavoriteView::SelectedBuddyItems()
{
	std::vector<Node*> vecTreeItem = GetSelectedItems();
	std::vector<Node*> vecTemp;
	std::vector<Node*> vecRet;
	for(std::vector<Node*>::iterator itr = vecTreeItem.begin(); itr != vecTreeItem.end(); itr++)
	{
		Node* pNode= *itr;

		if(pNode != NULL)
		{
			if(IsGroup(pNode)) // ׷
			{
				int i = 0;

				Node* pChild = pNode->child(0);

				while (pChild != NULL)
				{
					if (m_pDuiList)
					{
						vecTemp.push_back(pChild);
					}	
					pChild = pNode->child(++i);
				}
			}
			else // ã
			{
				if (pNode->parent()->parent() != NULL && pNode->has_children()==false)
				{

					vecTemp.push_back(pNode);
				}
			}
		}		
	}
	RepeatHitemFilter(vecTemp,vecRet);
	return vecRet;
}

void FavoriteView::Move( LPRECT lpRect )
{
	/*if (m_ctrlFavoriteTree.GetSafeHwnd())
	{
		m_ctrlFavoriteTree.MoveWindow(lpRect,TRUE);
	}*/
}

bool FavoriteView::IsExistGroup(LPCWSTR strUserID, int nGroupID)
{
	bool bRet=true;
  //  MainFrame* pFrame = NULL;

	
	BuddyUserIdMap::const_iterator buddyIterator = 
		m_userIdMap.find(make_pair(strUserID, nGroupID));

	if (buddyIterator == m_userIdMap.end())
	{
		bRet = false;
	}


	return bRet;
}

bool FavoriteView::IsGroupSelected() const
{
	bool bReturn = false;

	/*HTREEITEM hItem = m_ctrlFavoriteTree.GetLastSelectedItem();

	if (hItem != NULL)
	{
		if (m_ctrlFavoriteTree.IsGroup(hItem))
		{
			bReturn = true;
		}
	}*/

	return bReturn;
}

bool FavoriteView::IsBuddySelected() const
{
	bool bReturn = false;

	/*HTREEITEM hItem = m_ctrlFavoriteTree.GetSelectedItem();

	if (hItem != NULL)
	{
		if (m_ctrlFavoriteTree.IsGroup(hItem) == false)
		{
			TRACE("%s%d\n", __FUNCTION__, __LINE__);
			bReturn = true;
		}
	}*/

	return bReturn;
}

const IGTBuddyUser* FavoriteView::GetSelectedBuddy() const
{
	const IGTBuddyUser* pUser = NULL;
/*
	HTREEITEM hItem = m_ctrlFavoriteTree.GetSelectedItem();


	if (hItem != NULL)
	{
		if (m_ctrlFavoriteTree.IsGroup(hItem) == false)
		{
			pUser = (IGTBuddyUser *) m_ctrlFavoriteTree.GetItemData(hItem);
		}
	}
	else
	{

	}*/

	return pUser;
}

int FavoriteView::HitTestGroupId() const
{
	const IGTBuddyGroup* pGroup = NULL;
	int nGroupId = 0;


	return nGroupId;
}
const IGTBuddyGroup* FavoriteView::GetSelectedGroup() const
{
	const IGTBuddyGroup* pGroup = NULL;



	return pGroup;
}

void FavoriteView::EditGroupLabel( Node* hItem )
{
	
}

void FavoriteView::EditGroupLabelOn( int nGroupID /*= -1 */ )
{
	
}

const CString FavoriteView::GetDisPlayName(const NE_MEMBER_DATA* data)
{	
	
	CString strDisplayName = _T("");

	if (NULL == data)
		return strDisplayName;

	int nDisplayType = GET_CONFIG()->GetNameDisplayType();

	CString strEmpInfo = GetDisPlayEmpInfo(data);
	if( strEmpInfo == _T("[]") )
		strEmpInfo.Empty();

	CString strTelInfo = GetDisPlayTelInfo(data);
	if( strTelInfo == _T("[]") )
		strTelInfo.Empty();

	switch(nDisplayType)//<ȭǥù (0:̸+ȭ,1:̸,2:ȭ)
	{
	case 0: 
		strDisplayName.Format(_T(" %s %s %s"), strEmpInfo, strTelInfo, data->strNickName.c_str());
		break;
	case 1:
		strDisplayName.Format(_T(" %s %s"), strEmpInfo, strTelInfo);
		break;
	case 2:
		strDisplayName.Format(_T(" %s %s %s"), strEmpInfo, strTelInfo, data->strNickName.c_str());
		break;
	}

	return strDisplayName;
}

const CString FavoriteView::GetDisPlayEmpInfo(const NE_MEMBER_DATA* data)
{
	if (NULL == data)
		return L"";

	std::wstring strTmp = _T("[");

	if (GET_CONFIG()->GetAddInfoPart() && data->strDept.empty() != true)
		strTmp += data->strDept;

	if (GET_CONFIG()->GetAddInfoPosition() && data->strJobPos.empty() != true)
	{
		if(strTmp.length() > 1)
			strTmp += _T("/");

		strTmp += data->strJobPos;
	}

	if (GET_CONFIG()->GetAddInfoJob() && data->strJobDuty.empty() != true)
	{
		if(strTmp.length() > 1)
			strTmp += _T("/");

		strTmp += data->strJobDuty;
	}

	strTmp += _T("]");

	return strTmp.c_str();
}

const CString FavoriteView::GetDisPlayTelInfo(const NE_MEMBER_DATA* data)
{
	if (NULL == data)
		return L"";

	std::wstring strTmp = _T("[");

	if (GET_CONFIG()->GetAddInfoCellPhone() && data->strCellPhone.empty() != true)
		strTmp += data->strCellPhone;

	if (GET_CONFIG()->GetAddInfoTel() && data->strIncoTel.empty() != true)
	{
		if (strTmp.length() > 1)
			strTmp += _T("/");

		strTmp += data->strIncoTel;
	}

	if (GET_CONFIG()->GetAddInfoExtension() && data->strExtesion.empty() != true)
	{
		if (strTmp.length() > 1)
			strTmp += _T("/");

		strTmp += data->strExtesion;
	}

	if (GET_CONFIG()->GetAddEmail() && data->strEmail.empty() != true)
	{
		if (strTmp.length() > 1)
			strTmp += _T("/");

		strTmp += data->strEmail;
	}

	strTmp += _T("]");

	return strTmp.c_str();
}

void FavoriteView::SetIcon(Node* hItem, GTUserStatusType status)
{
	

}

void FavoriteView::UpdateStaus(LPCWSTR strUserId, const IGTBuddyUser *pUser, const NE_MEMBER_DATA* data)
{
	if (NULL == data)
	{
		ASSERT(FALSE);
	}
	CSingleLock lock(&m_csFavoriteView);
	lock.Lock();
	if (m_pDuiList == NULL)
	{
		m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
	}
	if (m_pDuiList != NULL)
	{
		m_pDuiList->UpdateStaus(strUserId, pUser, data);
	}
	lock.Unlock();
}

void FavoriteView::UpdateGroupName(const IGTBuddyGroup* pGroup, LPCWSTR displayText )
{
	CSingleLock lock(&m_csFavoriteView);
	lock.Lock();
	std::map<int, CString>::const_iterator groupIterator = m_groupIdMap574.find(pGroup->GetID());
	if (groupIterator != m_groupIdMap574.end())
	{
		CString oldName = groupIterator->second;
		if (m_pDuiList == NULL)
		{
			m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
		}
		if (m_pDuiList != NULL)
		{
			m_pDuiList->ReplaceGroupName(pGroup->GetID(), displayText);
		}
	}

	lock.Unlock();
}

void FavoriteView::SetController( FavoriteController* favoriteController )
{
	m_favoriteController = favoriteController;
	m_pDuiList->SetController(favoriteController);
}



void FavoriteView::DeleteBuddy(LPCWSTR strUserId, int nGroupId)
{
	CSingleLock lock(&m_csFavoriteView);
	lock.Lock();
	
	m_pDuiList->DeleteBuddy(strUserId, nGroupId);

	lock.Unlock();
}

void FavoriteView::DeleteGroup(int nGroupID)
{
	CSingleLock lock(&m_csFavoriteView);
	lock.Lock();

	m_pDuiList->DeleteGroup(nGroupID);

	lock.Unlock();
}

int FavoriteView::GetGroupID( const CString strGroupName )
{


	return -1;
}


void FavoriteView::UpdateAllBuddyDisplayNames()
{
	if (m_pDuiList == NULL)
	{
		m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
	}
	ASSERT(m_pDuiList != NULL);

	m_pDuiList->UpdataAllBuddyDisplayNames(GET_CONFIG()->GetNameDisplayType());
}


void FavoriteView::MenuMoveBuddy(UINT nCmdID,int nMenuStartID)
{	
	m_pDuiList->MenuMoveBuddy(nCmdID, nMenuStartID);
}
void FavoriteView::MenuCopyBuddy(UINT nCmdID, int nMenuStartID)
{
	m_pDuiList->MenuCopyBuddy(nCmdID, nMenuStartID);
}

void FavoriteView::GroupResort()
{
	m_pDuiList->DeleteAllItem();

	if (m_pDuiList == NULL)
	{
		m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
	}
	ASSERT(m_pDuiList != NULL);
	m_pDuiList->m_mapGroups.clear();
	m_favoriteController->AddRecentContactRroup(LoadStringFromResource(IDS_GROUP_RECENT_CONTACT));

    GET_MESSENGER_DLG()->GetMainFrame()->InitFavoriteListGroup();
    m_userIdMap.clear();
	GET_MESSENGER_DLG()->GetMainFrame()->InitFavoriteListBuddy(); 
	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	for (int index = 0; index < nGroupCount; index++)
	{
		const IGTBuddyGroup* pUser = g_pMessengerActor->GetBuddyGroupInfoFromIndex(index);
		int gid = pUser->GetID();
		ResortBuddyInGroup(gid);
	}
    ExpandBuddyGroup();
}

void FavoriteView::RedrawGroup()
{
	m_pDuiList->Invalidate();
}

void FavoriteView::ExpandRecentContactGroup()
{

}

void FavoriteView::ExpandBuddyGroup()
{
	CSingleLock lock(&m_csFavoriteView);
	lock.Lock();
	if (m_pDuiList == NULL)
	{
		m_pDuiList = GET_MESSENGER_DLG()->GetMainFrame()->GetBuddyList();
	}
	if (m_pDuiList != NULL)
	{
		m_pDuiList->ExPandGroup();
	}
	lock.Unlock();
}





void FavoriteView::SetEmptyText(const CString& strEmptyText)
{
	//m_ctrlFavoriteTree.SetEmptyText(strEmptyText);
}

void FavoriteView::OnRButtonEvent( bool bDown, int nIndex )
{
	m_pDuiList->OnRButtonEvent(bDown, nIndex);
}

bool FavoriteView::IsGroup( Node* pNode )
{
	return m_pDuiList->IsGroup(pNode);
}
